#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <glib.h>
#include <sys/stat.h>

#define MODULES_PATH "/lib/modules"
#define CDC_MBIM_DRIVER_PATH "kernel/drivers/net/usb/cdc_mbim.ko"

int asprintf(char **strp, const char *fmt, ...);

int
main (int argc, gchar *argv[]) {

	int kver_fd = -1;
	ssize_t read_count;
	char kversion[100];
	char *cdc_mbim_module_path;
	struct stat buf;

	kver_fd = open("/proc/sys/kernel/osrelease", O_RDONLY);
	read_count = read(kver_fd, &kversion, 100);

	/* remove trailing newline
	   https://launchpad.net/bugs/1800794 */
	int len = strlen(kversion);
	if( kversion[len-1] == '\n' )
		kversion[len-1] = 0;

	asprintf(&cdc_mbim_module_path, "%s/%s/%s",
		MODULES_PATH,
		kversion,
		CDC_MBIM_DRIVER_PATH);

	if (!stat(cdc_mbim_module_path, &buf))
		printf ("File \"%s\" found!\n", cdc_mbim_module_path);
	else
		printf ("File \"%s\" not found.\n", cdc_mbim_module_path);

	return 0;
}

